/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.6 Professional
Automatic Program Generator
 Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com
e-mail:office@hpinfotech.com

Project : 
Version : 
Date    : 10.06.2007
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>

//  
int tima; //  1- ;    ( unsigned int)   
int timb; //  2- ;    ( unsigned int)   
char count;        //    0- - 
char count2;       //    2- -
 
// External Interrupt 0 service routine
//        
interrupt [EXT_INT0] void ext_int0_isr(void)
{
if(PIND.2==1&&((MCUCR&0b00000001)==0b00000001)) // &&(MCUCR&0b00000001)==0b00000001
{                                               //    (   -)
    TCCR2=0x02;        //   6   
    TCNT2=0;
    count2=0;   
    MCUCR&=0b11111110; //    
    count=0;           //   1- 
    TCNT0=0x00;   
}
if(PIND.2==0&&((MCUCR&0b00000001)==0b00000000)) //&&((MCUCR&0b00000001)==0b00000000)
{                                               //    (   -)
    MCUCR|=0b00000001; //    
    tima=(int)(count*256+TCNT0); //   
}
}

// External Interrupt 1 service routine
//        
interrupt [EXT_INT1] void ext_int1_isr(void)
{
if(PIND.3==1&&((MCUCR&0b00000100)==0b00000100))
{
    TCCR2=0x02;        //   6   
    TCNT2=0;
    count2=0;
    MCUCR&=0b11111011; //    
    count=0;           //   2- 
    TCNT0=0x00;
}
if(PIND.3==0&&((MCUCR&0b00000100)==0b00000000))
{
    MCUCR|=0b00000100; //    
    timb=(int)(count*256+TCNT0); //   
}
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
    count++;
}
// Timer 1 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
    count2++;
}

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out 
// State6=T State5=T State4=T State3=T State2=T State1=0 State0=0 
PORTC=0x00;
DDRC=0x03;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
TCCR0=0x02;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x02;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: On
// INT1 Mode: Rising Edge
GICR|=0xC0;
MCUCR=0x0F;
GIFR=0xC0;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x41;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// Global enable interrupts
#asm("sei")

    while (1)
    {
      // Place your code here
      if((int)(count2*256+TCNT2)>6000) //        6
      {
          if(tima!=0&&timb!=0)   
          timb=timb-tima+1500;                  //  
          if(tima!=0)                           //   1- 
          {
              count=0;
              TCNT0=0;
              PORTC.0=1;
              while((int)(count*256+TCNT0)<tima); //  1- 
              PORTC.0=0;
              tima=0;
          }
          if(timb!=0)                           //   2- 
          {
              count=0;
              TCNT0=0;      
              PORTC.1=1;
              while((int)(count*256+TCNT0)<timb); //  2- 
              PORTC.1=0;
              timb=0;
          }
          TCCR2=0x00;                           //  6 
          count2=0;
          TCNT2=0;
      }     
    };
}
